<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Document</title>
  </head>
  <body>
    <!-- Напишите функцию-конструктор, создающую объект,
    реализующий такой функционал: у нас на странице есть вопрос.
    Пр первом клике на него под ним открывается ответ на вопрос.
    При повтором - ответ прячется.-->
    <!-- Разметка должна быть следующего вида: -->
    <!--    <a href="#" class="question">Вопрос</a>-->

    <div id="root">

    </div>

    <script>
      
      // создаем константы для вопроса и ответа
      const questionText = "Вопрос";
      const questionAnswer = "Ответ";

      function Question (text, answer, classList) {
        this.text = text;
        this.answer = answer;
        this.classList = classList;
        this.render = function () {
          this.createElement();
          container.append(this.element);
          this.handleElementClick();
        }
        this.createElement = function () {
          this.element = document.createElement('div');
          this.element.className = `question ${this.classList.join(' ')}`; // преобразование массива в строку
          this.element.innerHTML = this.text;
        }
        this.handleElementClick = function () {
          this.element.addEventListener('click',() => {
            if(!this.open) {
              this.createAnswer();
            } else {
              this.removeAnswer();
            }
            this.open = !this.open
          })
        }
        this.createAnswer = function () {
          const newAnswer = document.createElement("p");
          newAnswer.innerHTML = this.answer;
          this.element.append(newAnswer);
        }
        this.removeAnswer = function () {
          this.element.querySelector('p').remove();
        }
        this.open = false;
        this.element = null;
      }
      
      // создаем объект вопроса с помощью конструктора
      const question1 = new Question(questionText, questionAnswer, [
        "btn",
        "btn-red",
      ]);

      const question2 = new Question("Stanislav", "Lashkov", [
        "btn",
        "btn-red",
      ]);

      const container = document.getElementById("root");
      question1.render(container);
      question2.render(container);

      // Объект вида
      // {
      //     text: вопрос,
      //     answer: ответ,
      //     classList: [],
      //     element: для ссылки на DOM-элемент,
      //     open: для хранения состояния открыт он или закрыт
      //     render: метод для создания элемента,

      // }
    </script>
  </body>
</html>
